/* ȿñ㲻ġ
 * shige
 * 11/06 2000
 * auhz.c
 *
 * $Id: auhz.c,v 1.3 2000-11-19 20:00:36+09 shige Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "g711.h"

#define MaxInt16 32767
#define Maxbuff 8192

void usage(void);
void putsound(FILE *snd,double h,int len,double vol);
double periodic1(double x);
double periodic2(double x);
void writei32(FILE *file,unsigned long int n);

int main(int argc,char *argv[])
{
    FILE *snd;
    int hz=440,len=8000;
    double vol=0.5;

    if(argc<2 || (hz=atoi(argv[1]))<=0
       || (len=atoi(argv[2]))<=0
       || (vol=atof(argv[3]))<0.0){
	usage();
	return 0;
    }
    if(vol>1.0) vol=1.0;
#if 0
    if((snd=fopen("/dev/audio","w"))==NULL){
	printf("File open error.\n");
	return 0;
    }
#else
    snd=stdout;
#endif
    fprintf(snd,".snd");
    writei32(snd,32);
    writei32(snd,8*len);
    writei32(snd,1);
    writei32(snd,8000);
    writei32(snd,1);
    writei32(snd,0);
    writei32(snd,0);
    putsound(snd,hz/8000.0,len,vol);
    return 0;
}

void usage(void)
{
    fprintf(stderr,"Usage: auhz [Hz] [msec] [vol]\n");
}

/* h*8000 Hz, len m äβ volume level vol ή
 * 12bit linear -> 8bit ulaw  linear2ulaw() 
 * 0<h<1, 0<vol<1
 */
void putsound(FILE *snd,double h,int len,double vol)
{
    int j;
    char buff[Maxbuff];
    double y;

#ifdef DEBUG1
fprintf(stderr,"(h,len,vol)=(%f,%d,%f)\n",h,len,vol);
#endif
    if(vol>1.0) vol=1.0;
    else if(vol<0.0) vol=0.0;
    for(j=1;j<=8*len;j++){
	y=vol*MaxInt16*periodic1(h*j);
#ifdef DEBUG1
fprintf(stderr,"%d %f\n",j,y);
#endif
	buff[0]=linear2ulaw(y);
	fwrite(buff,1,1,snd);
    }
    fflush(snd);
}

/*  1,  -1.0~1.0
 */
double periodic1(double x)
{
    return sin(2.0*M_PI*x);
}

double periodic2(double x)
{
    int j;

    j=x;
    return x-j;
}

void writei32(FILE *file,unsigned long int n)
{
    fputc((n>>24)&0x00ff,file);
    fputc((n>>16)&0x00ff,file);
    fputc((n>>8)&0x00ff,file);
    fputc(n&0x00ff,file);
}

